/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2024 KylinSoft  Co., Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 */
#include "cpudetailswidget.h"

#include <libkycpu.h>

CpuDetailsWidget::CpuDetailsWidget(QWidget *parent) : BaseDetailViewWidget(parent)
{
    this->setAttribute(Qt::WA_TranslucentBackground);
    initUI();
}

CpuDetailsWidget::~CpuDetailsWidget()
{
}

void CpuDetailsWidget::initUI()
{
    setTitle(tr("Processor"));
    setDetail(kdk_cpu_get_model());

    mCpuChartView = new KChartView();
    mCpuChartView->setAxisTitle("100%", QColor("#3790FA"), tr("CPU"));
    KChartAttr attr;
    attr.colorForeground = QColor("#3790FA");
    attr.colorAlpha = 154;
    mCpuChartView->addItemAttr(attr);

    mCpuGraphVLayout =  new QVBoxLayout();
    mCpuGraphVLayout->setContentsMargins(0,0,0,0);
    mCpuGraphVLayout->setSpacing(0);
    mCpuGraphVLayout->addWidget(mCpuChartView);

    mDetailModel = new CpuDetailsModel();
    mDetailList =  new DetailListTable(mDetailModel);

    mListHLayout = new QHBoxLayout();
    mListHLayout->addWidget(mDetailList);

    mMainLayout->addLayout(mCpuGraphVLayout);
    mMainLayout->addSpacing(8);
    mMainLayout->addLayout(mListHLayout);
}

void CpuDetailsWidget::onUpdateCpuChartView(qreal cpuPercent)
{
    mCpuChartView->onUpdateData(cpuPercent, 0);
}

void CpuDetailsWidget::onUpdateData()
{
    mDetailModel->onModelUpdated();
}
